#ifndef PIXELMAP_H
#define PIXELMAP_H

#include "Pixel.h"
#include <vector>
#include <map>
#include <string>

class PixelMap {

private:    

public:
    
    static const unsigned int PM_ERROR_CODE = 999999999;
    
    PixelMap(std::string data, bool verbose=false);
    ~PixelMap();
    
    std::map<unsigned int, Pixel*> pixelmap;

    void ReadPixelMap(std::map<unsigned int, Pixel*>& pixelmap, std::string data, bool verbose=false);
    void Print();

    unsigned int FPA_to_Pixel(unsigned int FPAcrate, unsigned int FPAboard, unsigned int FPApatch, unsigned int FPApixel, bool verbose=false);
    std::vector<unsigned int> HV_to_Pixel(unsigned int HVcrate, unsigned int HVboard, unsigned int HVchannel, bool verbose=false);
    unsigned int POS_to_Pixel(int POSx, int POSy, bool verbose=false);
    
    unsigned int Pixel_to_FPAcrate(unsigned int PixelID, bool verbose=false);
    unsigned int Pixel_to_FPAboard(unsigned int PixelID, bool verbose=false);
    unsigned int Pixel_to_FPApatch(unsigned int PixelID, bool verbose=false);
    unsigned int Pixel_to_FPApixel(unsigned int PixelID, bool verbose=false);

    unsigned int Pixel_to_HVcrate(unsigned int PixelID, bool verbose=false);
    unsigned int Pixel_to_HVboard(unsigned int PixelID, bool verbose=false);
    unsigned int Pixel_to_HVchannel(unsigned int PixelID, bool verbose=false);

    int Pixel_to_POSx(unsigned int PixelID, bool verbose=false);
    int Pixel_to_POSy(unsigned int PixelID, bool verbose=false);

};

#endif
